> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Block Account

> Blocks an account, preventing all API access.

`Unary` · [`Accounts`](/docs/api-reference/generated/account/overview)

Blocks an account, preventing all API access.

Use this method to:

* Revoke access for policy violations
* Handle abuse cases
* Enforce compliance requirements

When an account is blocked:

* All API requests return 403 PERMISSION\_DENIED
* All running environments are stopped
* All active subscriptions are cancelled

Requires the `block_account` permission.

### Examples

* Block account for policy violation:

  ```yaml theme={null}
  accountId: "f53d2330-3795-4c5d-a1f3-453121af9c60"
  reason: "Terms of Service violation - spam"
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.AccountService/BlockAccount
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.AccountService/BlockAccount" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "accountId": "<account-id>",
    "reason": "<reason>"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.account_pb2 as account_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = account_pb2.BlockAccountRequest(
      account_id="<account-id>",
      reason="<reason>",
  )
  response = ona.services.account.block_account(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { BlockAccountRequestSchema } from "@gitpod/sdk/gitpod/v1/account_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(BlockAccountRequestSchema, {
      accountId: "<account-id>",
      reason: "<reason>",
    });
    const response = await ona.services.account.blockAccount(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.BlockAccountRequest{
  		AccountId: "<account-id>",
  		Reason: "<reason>",
  	})
  	response, err := ona.Services.Account.BlockAccount(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "accountId": "<account-id>",
    "reason": "<reason>"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.BlockAccountRequest`

| Field       | Type   | Required | Description                                                                                                                                   |
| ----------- | ------ | -------- | --------------------------------------------------------------------------------------------------------------------------------------------- |
| `accountId` | string | Yes      | account\_id is the UUID of the account to block Constraints: `required=true, string.uuid=true`.                                               |
| `reason`    | string | Yes      | reason is the reason for blocking the account (required for audit trail) Constraints: `required=true, string.max_len=1024, string.min_len=1`. |

## Response

`gitpod.v1.BlockAccountResponse`

| Field                    | Type    | Required | Description                                                                 |
| ------------------------ | ------- | -------- | --------------------------------------------------------------------------- |
| `environmentsStopped`    | integer | No       | environments\_stopped is the number of environments that were stopped       |
| `subscriptionsCancelled` | integer | No       | subscriptions\_cancelled is the number of subscriptions that were cancelled |
